// CircDlg.cpp : implementation file
//

#include "stdafx.h"
#include "femmview.h"
#include "complex.h"
#include <afxtempl.h>
#include "problem.h"
#include "xyplot.h"
#include "femmviewdoc.h"
#include "CircDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCircDlg dialog


CCircDlg::CCircDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCircDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCircDlg)
	//}}AFX_DATA_INIT
}


void CCircDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCircDlg)
	DDX_Control(pDX, IDC_CIRCNAME, m_circname);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCircDlg, CDialog)
	//{{AFX_MSG_MAP(CCircDlg)
	ON_CBN_SELCHANGE(IDC_CIRCNAME, OnSelchangeCircname)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircDlg message handlers

void CCircDlg::OnSelchangeCircname() 
{
	if(NumCircuits==0) return;

	int k;
	char s[256],c[256];
	CString crslt;

	k=m_circname.GetCurSel();
	
	/*	members of CCircuit:
		CString CircName;
		CComplex  dVolts;
		CComplex  Amps;
		CComplex  J;
		int		CircType;
		int		Case;	*/

		if (TheDoc->Frequency==0)
		{
			sprintf(s,"Total current = %e Amps%c%c",
				TheDoc->circproplist[k].Amps.Re(),0x0D,0x0A);
			crslt=s;
			if (TheDoc->circproplist[k].Case==0){
				if(TheDoc->ProblemType==0)
				{
					sprintf(s,"Voltage gradient = %e V/m%c%c",
						TheDoc->circproplist[k].dVolts.Re(),0x0D,0x0A);
					crslt+=s;
					sprintf(s,"Impedance = %e Ohm/meter",
						-TheDoc->circproplist[k].dVolts.Re()/
						TheDoc->circproplist[k].Amps.Re());
				}
				else{
					sprintf(s,"Voltage gradient = %e V/rad%c%c",
						TheDoc->circproplist[k].dVolts.Re(),0x0D,0x0A);
					crslt+=s;
					sprintf(s,"Impedance = %e Ohm",
						-2.*PI*TheDoc->circproplist[k].dVolts.Re()/
						TheDoc->circproplist[k].Amps.Re());
				}
				crslt+=s;
			}
			else{
				sprintf(s,"Current Density = %e A/m^2",
						TheDoc->circproplist[k].J.Re());
				crslt+=s;
			}
		}
		else{
			sprintf(s,"Total current = %s Amps%c%c",
				TheDoc->circproplist[k].Amps.ToString(c),0x0D,0x0A);
			crslt=s;
			if (TheDoc->circproplist[k].Case==0){
				if(TheDoc->ProblemType==0)
				{
					CComplex imp;
					sprintf(s,"Voltage gradient = %s V/m%c%c",
						TheDoc->circproplist[k].dVolts.ToString(c),0x0D,0x0A);
					crslt+=s;
					imp=-(TheDoc->circproplist[k].dVolts/
						TheDoc->circproplist[k].Amps);
					sprintf(s,"Impedance = %s Ohm/meter",imp.ToString(c));
				}
				else{
					CComplex imp;
					sprintf(s,"Voltage gradient = %s V/rad%c%c",
						TheDoc->circproplist[k].dVolts.ToString(c),0x0D,0x0A);
					crslt+=s;
					imp=-2.*PI*(TheDoc->circproplist[k].dVolts/
						TheDoc->circproplist[k].Amps);
					sprintf(s,"Impedance = %s Ohm",imp.ToString(c));
				}
				crslt+=s;
				
			}
			else{
				sprintf(s,"Current Density = %s A/m^2",
						TheDoc->circproplist[k].J.ToString(c));
				crslt+=s;
			}
		}

	
	SetDlgItemText(IDC_CIRCRESULT,crslt);
	
}

BOOL CCircDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	int i;
	
	NumCircuits=TheDoc->circproplist.GetSize();
	for(i=0;i<NumCircuits;i++)
		m_circname.AddString(TheDoc->circproplist[i].CircName);
	
	if(NumCircuits!=0){
		m_circname.SetCurSel(0);
		OnSelchangeCircname();
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
