
// #define PI 3.141592653589793238462643383
#define SmallNo 1.e-14

class CComplex
{
	public:
		// data members
		double re,im;

		// member functions
		CComplex();
		CComplex(double x, double y);
		CComplex Sqrt();
		CComplex Conj();
		CComplex Inv();
		void Set(double x, double y);
		double Abs();
		double Arg();
		double Re();
		double Im();
		char* ToString(char *s);
		
	//operator redefinition
		//Addition
		CComplex operator+(CComplex z );
		CComplex operator+(double z);
		CComplex operator+(int z);
		friend CComplex operator+( int x, CComplex y );
		friend CComplex operator+( double x, CComplex y );
		CComplex operator+=(CComplex z);
		CComplex operator+=(double z);
		CComplex operator+=(int z);

		//Subtraction
		CComplex operator-();
		CComplex operator-(CComplex z );
		CComplex operator-(double z);
		CComplex operator-(int z);
		friend CComplex operator-( int x, CComplex y );
		friend CComplex operator-( double x, CComplex y );
		CComplex operator-=(CComplex z);
		CComplex operator-=(double z);
		CComplex operator-=(int z);

		//Multiplication
		CComplex operator*(CComplex z );
		CComplex operator*(double z);
		CComplex operator*(int z);
		friend CComplex operator*( int x, CComplex y );
		friend CComplex operator*( double x, CComplex y );
		CComplex operator*=(CComplex z);
		CComplex operator*=(double z);
		CComplex operator*=(int z);

		//Division
		CComplex operator/(CComplex z );
		CComplex operator/(double z);
		CComplex operator/(int z);
		friend CComplex operator/( int x, CComplex y );
		friend CComplex operator/( double x, CComplex y );
		CComplex operator/=(CComplex z);
		CComplex operator/=(double z);
		CComplex operator/=(int z);

		//Equals
		CComplex operator=(double z);
		CComplex operator=(int z);

		//Tests
		BOOL operator==(CComplex z);
		BOOL operator==(double z);
		BOOL operator==(int z);
		BOOL operator!=(CComplex z);
		BOOL operator!=(double z);
		BOOL operator!=(int z);

	private:

};

// useful functions...
#define I CComplex(0,1)
double cRe(CComplex a);
double cIm(CComplex a);
double abs(CComplex x);
double arg(CComplex x);
CComplex exp(CComplex x);
CComplex sqrt(CComplex x);
CComplex tanh(CComplex x);
CComplex sinh(CComplex x);
CComplex cosh(CComplex x);
CComplex cos(CComplex x);
CComplex acos(CComplex x);
CComplex sin(CComplex x);
CComplex asin(CComplex x);
CComplex tan(CComplex x);
CComplex atan(CComplex x);
CComplex log(CComplex x);
CComplex pow(CComplex x, int y);
CComplex pow(CComplex x, double y);
CComplex pow(CComplex x, CComplex y);





// support for old use of CComplex...
CComplex Mult(CComplex a, CComplex b);
CComplex Mult(double a, CComplex b);
CComplex Mult(CComplex a, double b);

CComplex Div(CComplex a, CComplex b);
CComplex Div(CComplex a, double b);
CComplex Div(double a, CComplex b);

CComplex Add(CComplex a, CComplex b);
CComplex Add(CComplex b, double a);
CComplex Add(double a, CComplex b);

CComplex Subt(CComplex a, CComplex b);
CComplex Subt(CComplex a, double b);
CComplex Subt(double a, CComplex b);




